! PSPI shot-profile migration
! uses split-step fourier downward continuation  with N reference velocities.
! written by Brad Artman

program Shotprofile
  use wei_SPmig
  use wei_wem
  use wei_image
  use wei_ssf
  use wei_sll
  use sep
  use triangle2
  logical::verb
  integer::stat,ierr,iverb,n,i
  integer      :: time0(8), time1(8)
  real         :: start, finish

  !----------------------------------------------------------------
#ifdef TIME
  call date_and_time(values=time0)
  start_time = time0 (5) * 3600 + time0 (6) * 60 &
               + time0 (7) + 0.001 * time0 (8)
#endif  
  call sep_init(SOURCE)
  call getch_add_string("head=/dev/null")
  call getch_add_string("noheader=y")
  call set_no_putch()
!----------------------------------------------------------------
  call SPmig_init(SLin=sll_init,&
                  WCin=kxmigN_init,&
                  FKin=wem_init,&
                  FXin=ssf_init,&
                  IGin=ig_init,&
                  SMin=triangle2_init)
#ifdef TIME
  call date_and_time(values=time1)
  finish_time = time1 (5) * 3600 + time1 (6) * 60 &
                + time1 (7) + 0.001 * time1 (8)
  if(run%verb)write(0,*) '        * '
  if(run%verb)write(0,'(8x,a,f12.3,a)')' * Main initiallization: ', &
                finish_time - start_time,' (s)'
#endif  

  stat=SPmig(.true.,down%add,down%R,down%D,down%D_d, &
             SLop=sll, &
             WCop=kxmigN_SSR, &
             FKop=wem,&
             FXop=ssf,&
             IGop=Higop,&
             MIGop=MultIGop,&
             NDIGop=NdIGop,&
             NUIGop=NuIGop,&
             SMop=triangle2_lop)

#ifdef TIME
  call date_and_time(values=time1)
  finish_time = time1 (5) * 3600 + time1 (6) * 60 &
    + time1 (7) + 0.001 * time1 (8)

  if(run%verb)write(0,'(8x,a,f10.2,a)')' Total elapsed time:', &
                (finish_time - start_time)/60.,' (m)'
#endif 
  call sep_end_prog()
  write(0,*)'Gracias a Dios-  TERMINE !'
  call exit(0)

end program Shotprofile
