module triangle2
  use adj_mod
  use wei_down
  ! triangle smoothing in 2-D

  use triangle
  use triangle
  implicit none
  integer ,private :: b1, b2, n1, n2
  real,dimension(:,:),allocatable ,private :: tmp
contains
!----------------------------------------------------------------
!  integer function triangle2_init(b1_in,b2_in,n1_in,n2_in)
  integer function triangle2_init()
    integer :: b1_in
    integer :: b2_in
    integer :: n1_in
    integer :: n2_in
    b1=down%rectx
    b2=down%recty
    n1=down%amx%n
    n2=down%amy%n
    allocate(tmp(n1,n2))
 end function triangle2_init
!---------------------------------------------------------------- 
  integer function triangle2_lop(adj,add,x,y)
    logical,intent(in) :: adj,add
    real :: x(:),y(:)
    triangle2_lop=0
    call adjnull(adj,add,x,y)
    call triangle2_lop2(adj,x,y)
  end function triangle2_lop
!----------------------------------------------------------------
  subroutine triangle2_lop2(adj,x,y)
    logical, intent(in)::  adj
    real :: x(n1,n2)
    real :: y(n1,n2)
    integer i1, i2, stat1, stat2
    if (b1 > 1) then
       call triangle_init (b1,n1)
       do i2 = 1, n2
          if (b2 > 1) then
             if (adj) then
                stat1 = triangle_lop (adj, .false., tmp (:,i2), y (:,i2))
             else
                stat1 = triangle_lop (adj, .false., x (:,i2), tmp (:,i2))
             end if
          else
             stat1 = triangle_lop (adj, .true., x (:,i2), y (:,i2))
          end if
       end do
       call triangle_close ()
    end if
    if (b2 > 1) then
       call triangle_init (b2,n2)
       do i1 = 1, n1
          if (b1 > 1) then
             if (adj) then
                stat2 = triangle_lop (adj, .true., x (i1,:), tmp (i1,:))
             else
                stat2 = triangle_lop (adj, .true., tmp (i1,:), y (i1,:))
             end if
          else
             stat1 = triangle_lop (adj, .true., x (i1,:), y (i1,:))
          end if
       end do
       call triangle_close ()
    end if
  end subroutine triangle2_lop2
!----------------------------------------------------------------
  subroutine triangle2_close()
    deallocate(tmp)
  end subroutine triangle2_close
!----------------------------------------------------------------
end module triangle2
