module triple
  use adj_mod
! put a triple impulse	

  implicit none
  integer ,private :: nb, nx, wt
  contains
  subroutine triple_init(nb_in,nx_in,wt_in)
    integer :: nb_in
    integer :: nx_in
    integer :: wt_in
    nb=nb_in
    nx=nx_in
    wt=wt_in
  end subroutine
  integer function triple_lop(adj,add,x,y)
    logical,intent(in) :: adj,add
    real :: x(:),y(:)
    if (adj) then
      triple_lop=0
      call adjnull(adj,add,x,y)
      x (1:nx) = x (1:nx) + (y (1       :nx       ) - 2 *             &
      &     y (1 +   nb:nx +   nb) +                      y (1 + 2*nb:&
      &nx + 2*nb)) /wt
    else
      y (1       :nx       ) = y (1       :nx       ) +   x (1:nx) /wt
      y (1 +   nb:nx +   nb) = y (1 +   nb:nx +   nb) - 2*x (1:nx) /wt
      y (1 + 2*nb:nx + 2*nb) = y (1 + 2*nb:nx + 2*nb) +   x (1:nx) /wt
    end if
  end function
end module
